SystemOrganization addCategory: #ConfigurationOfSoup!

Object subclass: #ConfigurationOfSoup
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSoup'!

!ConfigurationOfSoup commentStamp: '<historical>' prior: 0!
!!!!!!Current loading expressions and dev history
 
[[[
(ConfigurationOfSoup project version: #'stable') load
(ConfigurationOfSoup project version: '1.4') load
]]]

21/02/2013 - Migrated to SmalltalkHub.
[[[
(ConfigurationOfSoup project version: '1.4') load
]]]

Adding better stable version.
[[[
(ConfigurationOfSoup project version: '1.3') load
]]]

Todo: update when XMLSupport will be migrated to Smalltalk.!

!ConfigurationOfSoup class methodsFor: 'private' stamp: 'sd 1/13/2011 16:29'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfSoup class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/23/2013 15:59'!
catalogChangeLog
		
 ^ '- Version 1. 4 21/02/2013 migrated to SmalltalkHub
[[[
(ConfigurationOfSoup project version: ''1.4'') load
]]]
- Version 1.3  adding better stable version.
[[[
(ConfigurationOfSoup project version: ''1.3'') load
]]]
'
	
	! !

!ConfigurationOfSoup class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/23/2013 16:03'!
catalogDescription

^ 
'Soup is a frameworks for scrapping HTML. It offers a simplified query mechanism to abstract over the XML and HTML structures of a document.'! !

!ConfigurationOfSoup class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/23/2013 21:50'!
catalogKeyClassesAndExample

	^ 'It is composed of some keys classes: 
		
- ==SoupElement== is the root of elements that are extracted during the parsing of an HTML document. Contrary to traditional HTML Parser, Soup produces a limited set of elements which approximate the HTML elements but supports querying and extracting information. 
		
- Soup. ==Soup== is the main public class of the package. It is the class to interact with as shown by the tests.

The best way to get started is to get a soup of html elements using ==Soup class>>fromString:== as follows:

[[[ 
	Soup fromString: ''http://www.bedetheque.com/album-105582-BD-Atomium-Express.html'' 
	    asUrl retrieveContents
]]]
	
Tests of the ==Soup== class are the place to start to learn the API.'! !

!ConfigurationOfSoup class methodsFor: 'catalog' stamp: 'StephaneDucasse 8/23/2013 16:04'!
catalogKeywords
	^ #(HTML web query scrapping Soup XPath)
	! !

!ConfigurationOfSoup class methodsFor: 'private' stamp: 'sd 1/13/2011 16:29'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfSoup class methodsFor: 'metacello support' stamp: 'sd 1/13/2011 16:28'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSoup class methodsFor: 'metacello support' stamp: 'sd 1/13/2011 16:28'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfSoup class methodsFor: 'load' stamp: 'sd 1/13/2011 16:27'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfSoup class methodsFor: 'load' stamp: 'sd 1/13/2011 16:31'!
loadDefault
	"self loadDefault"

	"^ self loadMostRecentCoreWithTests"
	^ self load.! !

!ConfigurationOfSoup class methodsFor: 'load' stamp: 'sd 1/13/2011 16:28'!
loadMostRecentCoreWithTests
	^self project lastVersion load: #('Core' 'Tests')! !

!ConfigurationOfSoup class methodsFor: 'metacello support' stamp: 'sd 1/13/2011 16:28'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfSoup class methodsFor: 'accessing' stamp: 'sd 1/13/2011 16:27'!
project

	^self new project! !

!ConfigurationOfSoup class methodsFor: 'metacello support' stamp: 'sd 1/13/2011 16:28'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfSoup methodsFor: 'baselines' stamp: 'StephaneDucasse 8/10/2013 16:24'!
XMLSupportProjectSpec: spec
	^ spec
		className: 'ConfigurationOfXMLSupport';
		versionString: #stable;
		repository: 'http://www.squeaksource.com/XMLSupport'! !

!ConfigurationOfSoup methodsFor: 'baselines' stamp: 'StephaneDucasse 8/23/2013 16:08'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec description: 'First Full Configuration'.
			spec author: 'StephaneDucasse'.
			spec timestamp: '29/12/2011 12:29'.
			spec repository: 'http://www.squeaksource.com/Soup'.
			spec
				package: 'Soup-Core' with: [ spec requires: 'XMLSupport' ];
				package: 'Soup-Tests-Core' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-Help' with: [ spec requires: 'Soup-Core' ].
			spec project: 'XMLSupport' with: [ self XMLSupportProjectSpec: spec ] ]! !

!ConfigurationOfSoup methodsFor: 'baselines' stamp: 'StephaneDucasse 8/10/2013 16:24'!
baseline11: spec
	<version: '1.1-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec description: 'Adding Camillo Bruni XPath extension'.
			spec author: 'StephaneDucasse'.
			spec timestamp: '31/12/2011 12:29'.
			spec repository: 'http://www.squeaksource.com/Soup'.
			spec
				package: 'Soup-Core' with: [ spec requires: 'XMLSupport' ];
				package: 'Soup-Tests-Core' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-Help' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-XPath' with: [ spec requires: 'Soup-Core' ].
			spec project: 'XMLSupport' with: [ self XMLSupportProjectSpec: spec ] ]! !

!ConfigurationOfSoup methodsFor: 'baselines' stamp: 'StephaneDucasse 8/10/2013 16:24'!
baseline13: spec
	<version: '1.3-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec description: 'Adding Camillo Bruni XPath extension'.
			spec author: 'StephaneDucasse'.
			spec timestamp: '31/12/2011 12:29'.
			spec repository: 'http://www.squeaksource.com/Soup'.
			spec
				package: 'Soup-Core' with: [ spec requires: 'XMLSupport' ];
				package: 'Soup-Tests-Core' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-Help' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-XPath' with: [ spec requires: 'Soup-Core' ].
			spec project: 'XMLSupport' with: [ self XMLSupportProjectSpec: spec ] ].
	spec
		for: #zinc
		do: [ 
			spec
				package: 'Soup-Zinc';
				package: 'Soup-Core' with: [ spec includes: 'Soup-Zinc' ] ]! !

!ConfigurationOfSoup methodsFor: 'baselines' stamp: 'StephaneDucasse 8/23/2013 16:08'!
baseline14: spec
	<version: '1.4-baseline'>
	spec
		for: #pharo
		do: [ 
			spec blessing: #baseline.
			spec description: 'Migrated to SmalltalkHub'.
			spec author: 'StephaneDucasse'.
			spec timestamp: '21/02/2013'.
			spec repository: self repositoryUrlString.
			spec
				package: 'Soup-Core' with: [ spec requires: 'XMLSupport' ];
				package: 'Soup-Tests-Core' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-Help' with: [ spec requires: 'Soup-Core' ];
				package: 'Soup-XPath' with: [ spec requires: 'Soup-Core' ].
			spec project: 'XMLSupport' with: [ self XMLSupportProjectSpec: spec ].
			spec
				group: 'default' with: #('Core' 'Tests');
				group: 'Core' with: #('Soup-Core' 'Soup-XPath');
				group: 'Tests' with: #('Soup-Tests-Core') ].
	spec
		for: #zinc
		do: [ 
			spec
				package: 'Soup-Zinc';
				package: 'Soup-Core' with: [ spec includes: 'Soup-Zinc' ] ]! !

!ConfigurationOfSoup methodsFor: 'accessing' stamp: 'SeanDeNigris 2/9/2013 15:53'!
customProjectAttributes
	| attributes |
	attributes := OrderedCollection new.
	(Smalltalk hasClassNamed: #ZnClient)
		ifTrue: [ attributes add: #zinc ].
	^ attributes! !

!ConfigurationOfSoup methodsFor: 'symbolic versions' stamp: 'DamienCassou 6/26/2013 10:14'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.2'.
	spec for: #'pharo1.3.x' version: '1.1'.
	spec for: #'pharo1.4.x' version: '1.3'.
	spec for: #'pharo2.x' version: '1.4'.
	spec for: #'pharo3.x' version: '1.4'.! !

!ConfigurationOfSoup methodsFor: 'accessing' stamp: 'SeanDeNigris 2/9/2013 16:21'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSoup methodsFor: 'baselines' stamp: 'StephaneDucasse 8/10/2013 16:27'!
repositoryUrlString
	^ 'http://www.smalltalkhub.com/mc/PharoExtras/Soup/main'! !

!ConfigurationOfSoup methodsFor: 'symbolic versions' stamp: 'DamienCassou 6/26/2013 10:13'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo1.3.x' version: '0.2'.
	spec for: #'pharo1.4.x' version: '0.2'.
	spec for: #'pharo2.x' version: '1.4'.	
	spec for: #'pharo3.x' version: '1.4'.! !

!ConfigurationOfSoup methodsFor: 'versions' stamp: 'sd 1/13/2011 16:14'!
version01: spec 

	<version: '0.1'> 
	spec for: #common do: [ spec repository: 'http://www.squeaksource.com/Soup'. 
	spec 
		package: 'Soup-Core' with: 'Soup-Core-StephaneDucasse.6'; 
		package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-StephaneDucasse.2';
		package: 'Soup-Help' with: 'Soup-Help-StephaneDucasse.2' ].! !

!ConfigurationOfSoup methodsFor: 'versions' stamp: 'sd 3/27/2011 19:21'!
version02: spec 

	<version: '0.2'> 
	spec for: #common do: [ spec repository: 'http://www.squeaksource.com/Soup'. 
	spec 
		package: 'Soup-Core' with: 'Soup-Core-sd.11'; 
		package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-sd.3';
		package: 'Soup-Help' with: 'Soup-Help-StephaneDucasse.2' ].! !

!ConfigurationOfSoup methodsFor: 'versions' stamp: 'AlexandreBergel 1/17/2012 16:19'!
version10: spec
	<version: '1.1' imports: #('1.1-baseline' )>

	spec for: #'pharo' do: [
		spec blessing: #'development'.
		spec project: 'XMLSupport' with: [
				spec
					versionString: '1.2.0';
					loads: #('XML-Parser' 'XML-Tests-Parser' ) ].
		spec 
			package: 'Soup-Core' with: 'Soup-Core-CamilloBruni.14';
			package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-AlexandreBergel.5';
			package: 'Soup-Help' with: 'Soup-Help-StephaneDucasse.2';
			package: 'Soup-XPath' with: 'Soup-XPath-CamilloBruni.3'. ].
! !

!ConfigurationOfSoup methodsFor: 'versions' stamp: 'AlexandreBergel 1/17/2012 16:19'!
version12: spec
	<version: '1.2' imports: #('1.1-baseline' )>

	spec for: #'pharo' do: [
		spec blessing: #'baseline'.
		spec description: 'Adding Camillo Bruni XPath extension'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '31/12/2011 12:29'.
		spec project: 'XMLSupport' with: #'stable'.
		spec 
			package: 'Soup-Core' with: 'Soup-Core-CamilloBruni.14';
			package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-AlexandreBergel.5';
			package: 'Soup-Help' with: 'Soup-Help-StephaneDucasse.2';
			package: 'Soup-XPath' with: 'Soup-XPath-CamilloBruni.3'. ].
! !

!ConfigurationOfSoup methodsFor: 'versions' stamp: 'SeanDeNigris 2/9/2013 16:25'!
version13: spec
	<version: '1.3' imports: #('1.3-baseline' )>

	spec for: #'pharo' do: [
		spec blessing: #'development'.
		spec description: '- New Help version
- Fix for Pharo 2.0.'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '08/02/2013 11:27'.
		spec project: 'XMLSupport' with: #'stable'.
		spec 
			package: 'Soup-Core' with: 'Soup-Core-CamilloBruni.14';
			package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-AlexandreBergel.5';
			package: 'Soup-Help' with: 'Soup-Help-SeanDeNigris.3';
			package: 'Soup-XPath' with: 'Soup-XPath-CamilloBruni.3'. ].

	spec for: #'pharo2.x' do: [
		spec blessing: #'development'.
		spec description: '- New Help version
- Fix for Pharo 2.0.'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '08/02/2013 11:27'.
		spec project: 'XMLSupport' with: #'stable'.
		spec 
			package: 'Soup-Core' with: 'Soup-Core-SeanDeNigris.15';
			package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-SeanDeNigris.7';
			package: 'Soup-Help' with: 'Soup-Help-SeanDeNigris.3';
			package: 'Soup-XPath' with: 'Soup-XPath-CamilloBruni.3'. ].
		
	spec for: #zinc do: [
		spec 
			package: 'Soup-Zinc' with: 'Soup-Zinc-SeanDeNigris.1' ]! !

!ConfigurationOfSoup methodsFor: 'versions' stamp: 'StephaneDucasse 2/22/2013 09:56'!
version14: spec
	<version: '1.4' imports: #('1.4-baseline' )>

	spec for: #'pharo' do: [
		spec blessing: #'development'.
		spec description: '- New Help version
- Fix for Pharo 2.0.'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '08/02/2013 11:27'.
		spec project: 'XMLSupport' with: #'stable'.
		spec 
			package: 'Soup-Core' with: 'Soup-Core-CamilloBruni.14';
			package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-AlexandreBergel.5';
			package: 'Soup-Help' with: 'Soup-Help-SeanDeNigris.3';
			package: 'Soup-XPath' with: 'Soup-XPath-CamilloBruni.3'. ].

	spec for: #'pharo2.x' do: [
		spec blessing: #'development'.
		spec description: '- New Help version
- Fix for Pharo 2.0.'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '08/02/2013 11:27'.
		spec project: 'XMLSupport' with: #'stable'.
		spec 
			package: 'Soup-Core' with: 'Soup-Core-SeanDeNigris.15';
			package: 'Soup-Tests-Core' with: 'Soup-Tests-Core-SeanDeNigris.7';
			package: 'Soup-Help' with: 'Soup-Help-SeanDeNigris.3';
			package: 'Soup-XPath' with: 'Soup-XPath-CamilloBruni.3'. ].
		
	spec for: #zinc do: [
		spec 
			package: 'Soup-Zinc' with: 'Soup-Zinc-SeanDeNigris.1' ]! !
